function createTime(parent) {
  if (!parent)
    parent = ".content"
  if (typeof parent == "string")
    parent = document.querySelector(parent)
  var time = document.createElement("div")
  time.className = "time"
  if (parent)
    parent.appendChild(time)
  return time
}

function formatTime(timestamp) {
  var format = akamai.amp.Utils.formatZeroFill
  var date = new Date(timestamp);
  var hours = format(date.getHours());
  var minutes = format(date.getMinutes())
  var seconds = format(date.getSeconds())
  var ms = format((date.getMilliseconds() / 1000).toFixed(3), 3).split(".").pop()
  return hours + ":" + minutes + ":" + seconds + "." + ms;
}

var displayInterval;
var displayHandlers = [];

function displayUpdate() {
  if (displayInterval != null)
    return

  displayInterval = setInterval(function () {
    displayHandlers.forEach(function (handler) {
      handler()
    })
  }, 83)
}

function display(func, parent) {
  var time = createTime(parent)
  displayHandlers.push(function () {
    var value = "";
    try {
      value = func();
    } catch (error) {
      value = ""
    }
    time.innerHTML = value;
  })
  displayUpdate()
}

function displayTime(getTime, label, parent) {
  display(function () {
    var value = (label) ? label + ": " : "";
    var date = getTime()
    if (!isNaN(date) && date > 0) {
      value += formatTime(date)
    }
    return value;
  }, parent)
}
